'****************************************************************
'* Titulo  : Proyecto Titanium 24                               *
'* Nombre  : TTANIUM24_X_xx.BAS                                 *
'* Autor   : Ricardo Gamboa                                     *
'* Notice  : Copyright (c) 2002 GAMBOA FIRMWARE                 *
'*         : All Rights Reserved                                *
'* Fecha   : 14/01/2018                                         *
'* Version : 1.00                                               *
'* MCU     : PIC24FJ64GA306                                     *
'* COMPILER: PROTON 24 Compiler 1.0.4.1                         *
'*         :                                                    *
'* REVISIN:                                                    *
'* REVISIN:                                                    *
'* REVISIN:                                                    *
'* REVISIN:                                                    *
'****************************************************************

'DESCRIPCION FUNCIONAMIENTO:
'Prueba de arranque con FRC de 8MHz  OK
'Prueba de Encender LED1 y LED2      OK
'Prueba S1 y S2                      OK



'*************************************************************************
'** DECLARES
'*************************************************************************
  DEVICE = 24FJ256GA705

  DECLARE XTAL = 8


'*************************************************************************
'** INCLUDES
'*************************************************************************
   INCLUDE "ConfigFuses.inc"
   INCLUDE "ConfigPines.inc"


'*************************************************************************
'** VARIABLES
'*************************************************************************
  DIM TramaParaTransmitirU1[100]  AS BYTE 'Array donde se compone la trama que se desea enviar USART1
  DIM TramaParaTransmitirU2[100]  AS BYTE 'Array donde se compone la trama que se desea enviar USART2
  DIM BuferRecepcionUSART1[100]   AS BYTE 'Bufer de recepcion para USART1
  DIM BuferRecepcionUSART2[100]   AS BYTE 'Bufer de recepcion para USART2

  DIM CentinelaVive              AS DWORD = 0 'Contador para el tiempo del LED VIVE
  DIM TestigoVive                AS DWORD = 0 'Variable que guarda dos tipos de cuenta:  Ethernet conectado y desconectado

  DIM Tempo1_16                  AS WORD = 0 'Variable de uso general
  DIM Tempo2_16                  AS WORD = 0 '"

  DIM DesdeTxU1                  AS BYTE = 0 'Variables que guardan los lmites desde/hasta donde hay que transmitir USART1
  DIM HastaTxU1                  AS BYTE = 0
  DIM DesdeTxU2                  AS BYTE = 0 'Variables que guardan los lmites desde/hasta donde hay que transmitir USART2
  DIM HastaTxU2                  AS BYTE = 0
  DIM IndiceU1                   AS BYTE = 0 'Indice de por donde se va rellenando el bufer de recepcion de USART1
  DIM IndiceU2                   AS BYTE = 0 'Indice de por donde se va rellenando el bufer de recepcion de USART2
  DIM NumeroBytesTramaU1         AS BYTE = 0 'Numero de bytes recibidos en la trama de USART1
  DIM NumeroBytesTramaU2         AS BYTE = 0 'Numero de bytes recibidos en la trama de USART2

  DIM Tempo                      AS BYTE = 0 'Variable de uso general
  DIM Tempo1                     AS BYTE = 0 '=
  DIM Tempo2                     AS BYTE = 0 '=

  DIM F_Timeout                  AS BIT = 0 'Indica que ha ocurrido un timeout de lectura de banda magnetica
  DIM F_Segundo                  AS BIT = 0 'Flag que indica que ha transcurrido 1 segundo
  DIM F_TramaRecibidaU1          AS BIT = 0 'Indica que una trama se ha recibido por USART1
  DIM F_TramaRecibidaU2          AS BIT = 0 'Indica que una trama se ha recibido por USART2


'*************************************************************************
'** ALIAS
'*************************************************************************


  SYMBOL RGB_RED      LATA.0    'Pin rojo del led RGB
  SYMBOL RGB_GREEN    LATA.1    'Pin Verde del led RGB
  SYMBOL RGB_BLUE     LATC.7    'Pin Azul del led RGB
  SYMBOL LED1         LATA.8    'Pin LED1
  SYMBOL LED2         LATA.9    'Pin LED2
  SYMBOL S1           PORTA.11  'Switch1
  SYMBOL S2           PORTA.12  'Switch2

  SYMBOL T1ON         T1CON.15 'Timer1 ON/OFF
  SYMBOL T2ON         T2CON.15 'Timer2 ON/OFF
  SYMBOL T3ON         T3CON.15 'Timer2 ON/OFF

'*************************************************************************
'** CONSTANTES
'*************************************************************************
  SYMBOL TOCENTINELAVIVE       100000 'Tiempo de intermitecia del LED VIVE
  SYMBOL TOCENTINELAENTRADAS   60000  'Tiempo tras el que se interroga el control de entradas
  SYMBOL MAXVALORESPERAESCANER 65000  'Valor que ajusta el tiempo de desconexin del escaner despues de una lectura
  SYMBOL VIVEDESCONECTADO      100000 'Valor que ajusta el tiempo de intermitencia del led vive cuando esta sin conexion ethernet
  SYMBOL VIVECONECTADO         20000  ' Idem con conexion
  SYMBOL MAXPENDIENTECONEXION  65000 'Valor mximo que espera despus que enva el comando de estado de la conexin hasta cambiar a desconectado

  'Symbol for control 25LC256
  SYMBOL WREN_25LC256   %00000110 'Set the write enable latch (enable write operations)
  SYMBOL WRDI_25LC256   %00000100 'Reset the write enable latch (disable write operations)
  SYMBOL WRITE_25LC256  %00000010 'Write data to memory array beginning at selected address
  SYMBOL READ_25LC256   %00000011 'Read data from memory array beginning at selected address


'  SYMBOL TOCENTINELAENTRADAS 500000 'Tiempo tras el que se interroga el control de entradas


  SYMBOL STX      2  'ASCII STX
  SYMBOL ETX      3  'ASCII ETX
  SYMBOL LF       10 'ASCII LF
  SYMBOL ACK      6  'ASCII ACK
  SYMBOL NACK     21 'ASCII NACK
  SYMBOL SYN      22 'ASCII Synchronous Idle
  SYMBOL CRETURN  13 'ASCII Carriage Return

  SYMBOL APAGADO 0
  SYMBOL ENCENDIDO 1
  SYMBOL ONLINE  1
  SYMBOL OFFLINE 0


  GOTO Principal


Interrupciones:
'*************************************************************************
'** INTERRUPCION: T1Interrupt
'** Manejo de interrupcion para TMR1
'**
'** Parametros de entrada: ninguno
'** Parmetros de salida:  F_Segundo = 1 si un segundo ha transcurrido
'*************************************************************************

  ISR T1Interrupt  'Manejo de interrupcion para TMR1
    IFS0bits_T1IF = 0  'Limpiar flag de interrupcion
    F_Segundo = 1      'Flag que indica que ha transcurrido 1 segundo
    F_Timeout = 1 'Tmeout de lectura de banda magnetica
  ENDISR
'** FIN INTERRUPCION: T1Interrupt


'*************************************************************************
'** INTERRUPCION: T2Interrupt
'** Manejo de interrupcion para TMR2. Si una interrupcion TMR2 se produce
'** es que una trama no ha llegado a tiempo y hay que descartarla
'**
'** Parametros de entrada: ninguno
'** Parmetros de salida:  ninguno
'*************************************************************************

  ISR T2Interrupt  'Manejo de interrupcion para TMR2
    IFS0bits_T2IF = 0  'Limpiar flag de interrupcion
    T2ON = 0           'Paro TMR2 e inicializo
    TMR2 = 0
    IndiceU1 = 0       'Descarto trama
  ENDISR
'** FIN INTERRUPCION: T2Interrupt



'*************************************************************************
'** INTERRUPCION: T3Interrupt
'** Manejo de interrupcion para TMR3. Si una interrupcion TMR2 se produce
'** es que una trama no ha llegado a tiempo y hay que descartarla
'**
'** Parametros de entrada: ninguno
'** Parmetros de salida:  ninguno
'*************************************************************************

  ISR T3Interrupt  'Manejo de interrupcion para TMR2
    IFS0bits_T3IF = 0
    T3ON = 0           'Paro TMR2 e inicializo
    TMR3 = 0
    IndiceU2 = 0       'Descarto trama Usart2
  ENDISR
'** FIN INTERRUPCION: T2Interrupt


'*************************************************************************
'** INTERRUPCION: U1RXInterrupt
'** Manejo de interrupcion para recepcion de USART1
'**
'** Parametros de entrada: ninguno
'** Parmetros de salida:  Rellena el bufer de datos BuferRecepcionUSART1[]
'*************************************************************************

  ISR U1RXInterrupt

    IF U1STAbits_OERR = 1 THEN
      CLEAR U1STAbits_OERR 'limpio el error y termino
    ELSE
      BuferRecepcionUSART1[IndiceU1] = U1RXREG    'leo un byte de la USART1
      CLEAR IFS0bits_U1RXIF                       'Limpio el flag de interrupcion
      INC IndiceU1                                'Apunto a la nueva posicin para recarga
      T2ON = 1                                    'Activo el proceso de cuenta de timeout del puerto USART1
      TMR2 = 0
      IF BuferRecepcionUSART1[IndiceU1 - 1] = ETX OR IndiceU1 > 40  THEN 'Compruebo fin de trama
        NumeroBytesTramaU1 = IndiceU1 - 1
        IndiceU1 = 0
        F_TramaRecibidaU1 = 1 'He recibido una trama completa
        T2ON = 0  'paro e inicializo el timer2
        IFS0bits_T2IF = 0
        TMR2 = 0
      ENDIF 'de IF BuferRecepcionUSART1[IndiceU1 - 1] = ETX
    ENDIF 'de IF U1STAbits_OERR = 1
  ENDISR
'** FIN INTERRUPCION: U1RXInterrupt



'*************************************************************************
'** INTERRUPCION: U2RXInterrupt
'** Manejo de interrupcion para recepcion de USART2
'**
'** Parametros de entrada: ninguno
'** Parmetros de salida:  Rellena el bufer BuferRecepcionUSART2[] que llegan por USART2
'*************************************************************************

  ISR U2RXInterrupt
    IF U2STAbits_OERR = 1 THEN
      CLEAR U2STAbits_OERR 'limpio el error y termino
    ELSE
      BuferRecepcionUSART2[IndiceU2] = U2RXREG    'leo un byte de la USART2
      CLEAR IFS1bits_U2RXIF                       'Limpio el flag de interrupcion
      INC IndiceU2                                'Apunto a la nueva posicin para recarga
      T3ON = 1                                    'Activo el proceso de cuenta de timeout del puerto USART2
      TMR3 = 0
      IF BuferRecepcionUSART2[IndiceU2 - 1] = ETX OR IndiceU2 > 40  THEN 'Compruebo fin de trama
        NumeroBytesTramaU2 = IndiceU2 - 1
        IndiceU2 = 0
        F_TramaRecibidaU2 = 1 'He recibido una trama completa
        T3ON = 0  'paro e inicializo el timer3
        IFS0bits_T3IF = 0
        TMR3 = 0
      ENDIF 'de IF BuferRecepcionUSART2[IndiceU2 - 1] = ETX
    ENDIF 'de IF U2STAbits_OERR = 1
  ENDISR
'** FIN INTERRUPCION: U2RXInterrupt



'*************************************************************************
'** PROCEDIMIENTO: EncenderLedVive
'** Gestiona la intermitencia de un LED de estado VIVE
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC EncenderLedVive()

    INC CentinelaVive
'    IF F_TiempoEsperaEscaner = 1 THEN
'      INC CentinelaEsperaEscaner
'      IF  CentinelaEsperaEscaner >= MAXVALORESPERAESCANER THEN
'        F_TiempoEsperaEscaner = 0
'        CentinelaEsperaEscaner = 0
'      ENDIF
'    ENDIF
    IF CentinelaVive > TestigoVive THEN  'Controla el led vive apagando y encendiendo segun la conexion ethernet
      CentinelaVive = 0
    '  LED1 = ~ LED1
      LED2 = ~ LED2
    '  latb.2 = ~latb.2
    ENDIF 'de IF CentinelaVive > TOCENTINELAVIVE

  ENDPROC
'** FIN PROCEDIMIENTO: EncenderLedVive


'*************************************************************************
'** PROCEDIMIENTO: ComprobarEntradas()
'** Comprueba el estado de S1 y S2
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC ComprobarEntradas()
    IF S1 = 0 AND S2 = 1 THEN
      RGB_RED = 1
    ELSEIF  S1 = 1 AND S2 = 1 THEN
      RGB_RED = 0
    ENDIF 'if s1 = 1

    IF S1 = 1 AND S2 = 0  THEN
      RGB_GREEN = 1
    ELSEIF  S1 = 1 AND S2 = 1 THEN
      RGB_GREEN = 0
    ENDIF 'if s1 = 1

    IF S1 = 0 AND S2 = 0  THEN
      RGB_BLUE = 1
    ELSEIF  S1 = 1 AND S2 = 1 THEN
      RGB_BLUE = 0
    ENDIF 'if s1 = 1


  ENDPROC  'ComprobarEntradas()


'*************************************************************************
'** PROCEDIMIENTO: TMR1_Inicializar
'** Ajusta el Timer1 para funcionar segun queremos
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC TMR1_Inicializar()

    'REGISTER 12-1: T1CON: TIMER1 CONTROL REGISTER
    T1CON = %0000000000110000 'TMR1 Off
                              'Prescaler 1:256
                              'Internal clock OSC/2
    'Preparo el timer1 para interrupcion
    IFS0bits_T1IF = 0  ' Limpio el flag de interrupcion
'    IPC0bits_T1IP0 = 0 ' Ajusto prioridad 0
'    IPC0bits_T1IP1 = 0
'    IPC0bits_T1IP2 = 0
    IEC0bits_T1IE = 1  ' Habilito la interrupcion del TMR1
    TMR1 = 0           ' pongo a cero el registro del TMR1
    PR1 = 62500        ' Periodo de cuenta del TMR1, para contar 1 segundo

    T1ON = 0

  ENDPROC
'** FIN PROCEDIMIENTO: TMR1_Inicializar



'*************************************************************************
'** PROCEDIMIENTO: TMR2_Inicializar
'** Ajusta el Timer2 para funcionar segun queremos
'** El TMR2 se usa como contador de tiempo entre dos caracteres de una trama USART1
'** El sistema de comunicacin usado se basa en tramas que son inferiores a 15 bytes
'** generalmente. A la velocidad usada (9600) una trama de 15 bytes son 15ms aprox.
'** Cuando una trama se queda incompleta o aparece un ruido inesperado, sino hubiese un
'** mecanismo de control para eliminarla, aparecera en la siguiente trama.
'** El mecanismo de control usado es poner un tiempo suficientemente largo entre dos
'** caracteres consecutivos. De este modo cada nuevo caracter inicializa el contador y
'** no pasa nada, pero si se corta una trama, el trozo de trama recibido se desecha.
'** El tiempo de trama mximo puede ser 15ms. Nosotros vamos a poner un margen de timeout
'** de 16ms. Si en 16ms no ha venido el siguiente caracter se desecha la trama.
'**
'** Fosc=8MHz, FCY=FOSC/2=4MHz, T=0.25us, Total TMR2 65535x0.25us=16383us, que son 16ms aproximadamente
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC TMR2_Inicializar()

    'REGISTER 13-1: TxCON: TIMER2 CONTROL REGISTER
    T2CON = %0000000000000000  'TMR2 Off
                               'Prescaler 1:1
                               '16 bit counter
                               'Internal clock OSC/2
                               'T2CON.3 = 0 16 bit mode
     'Preparo el timer2 para interrupcion
    IFS0bits_T2IF = 0   'IFS0.7
'    IPC1bits_T2IP0 = 0
'    IPC1bits_T2IP1 = 0
'    IPC1bits_T2IP2 = 0
    IEC0bits_T2IE  = 1   'IEC0.7
    TMR2 = 0
    PR2 = 64000  ' Periodo de cuenta del TMR2, para contar 16ms
    T2ON = 0

  ENDPROC
'** FIN PROCEDIMIENTO: TMR2_Inicializar


'*************************************************************************
'** PROCEDIMIENTO: TMR3_Inicializar
'** Ajusta el Timer3 para funcionar segun queremos
'** Es el mismo mecanismo que el TMR2 para USART1. Pues aqui usamos TMR3 para USART2
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC TMR3_Inicializar()

    'REGISTER 13-2: TyCON: TIMER3 CONTROL REGISTER
    T3CON = %0000000000000000'%0000000000110000  'TMR3 Off
                               'Prescaler 1:1
                               '16 bit counter
                               'Internal clock OSC/2
     'Preparo el timer2 para interrupcion
    IFS0bits_T3IF = 0
'    IPC2bits_T3IP0 = 0
'    IPC2bits_T3IP1 = 0
'    IPC2bits_T3IP2 = 0
    IEC0bits_T3IE = 1
    TMR3 = 0
'    PR3 = 1875  ' Periodo de cuenta del TMR3, para contar 30ms, 30000us/16us=1875cuentas
    PR3 = 64000 ' Periodo de cuenta del TMR3, para contar 16ms
    T3ON = 0
  ENDPROC
'** FIN PROCEDIMIENTO: TMR3_Inicializar



'*************************************************************************
'** PROCEDIMIENTO: UART1_Inicializar
'** Ajusta el USART1 para funcionar segun queremos
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC UART1_Inicializar()

    DECLARE HSERIAL_BAUD = 9600
    DECLARE HRSOUT1_PIN = PORTB.6 ' Selecciona pin para TX en USART1, 'U1TX(RB6) Output from UART1
    DECLARE HRSIN1_PIN = PORTB.5  ' Selecciona pin para RX en USART1, 'U1RX(RB5) Input to UART1

'    'Preparo el UART1 para interrupcion de recepcion
    IFS0bits_U1RXIF = 0 'Flag de interrupcion de recepcion RX1
'    IPC2bits_U1RXIP0 = 0 'Prioridad de interrupcion 0
'    IPC2bits_U1RXIP1 = 0
'    IPC2bits_U1RXIP2 = 0
    IEC0bits_U1RXIE  = 1 'Habilitar interrupcion de recepcion RX1

  ENDPROC
'** FIN PROCEDIMIENTO: UART1_Inicializar


'*************************************************************************
'** PROCEDIMIENTO: UART2_Inicializar
'** Ajusta el USART2 para funcionar segun queremos
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC UART2_Inicializar()

    DECLARE HSERIAL2_BAUD = 9600
    DECLARE HRSOUT2_PIN = PORTB.8 ' Selecciona pin para TX en USART2, 'U2TX(RB8) Output from UART2
    DECLARE HRSIN2_PIN = PORTB.7  ' Selecciona pin para RX en USART2, 'U2RX(RB7) Input to UART2

    'Preparo el UART1 para interrupcion de recepcion
    IFS1bits_U2RXIF = 0  'Flag de interrupcion de recepcion RX2
'    IPC7bits_U2RXIP0 = 0 'Prioridad de interrupcion 0
'    IPC7bits_U2RXIP1 = 0
'    IPC7bits_U2RXIP2 = 0
    IEC1bits_U2RXIE = 1 'Habilitar interrupcion de recepcion RX2

  ENDPROC
'** FIN PROCEDIMIENTO: UART2_Inicializar

'*************************************************************************
'** PROCEDIMIENTO: OC1_Inicializar
'** Ajusta el modulo output compare para el canal 1 de PWM
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC OC1_Inicializar()

' OC1CON1 Bits
'  OC1CON1bits_TRIGMODE OC1CON1.3
'  OC1CON1bits_OCFLT0 OC1CON1.4
'  OC1CON1bits_OCFLT1 OC1CON1.5
'  OC1CON1bits_OCFLT2 OC1CON1.6
'  OC1CON1bits_ENFLT0 OC1CON1.7
'  OC1CON1bits_ENFLT1 OC1CON1.8
'  OC1CON1bits_ENFLT2 OC1CON1.9
'  OC1CON1bits_OCSIDL OC1CON1.13
'  OC1CON1bits_OCM0 OC1CON1.0
'  OC1CON1bits_OCM1 OC1CON1.1
'  OC1CON1bits_OCM2 OC1CON1.2
'  OC1CON1bits_OCTSEL0 OC1CON1.10
'  OC1CON1bits_OCTSEL1 OC1CON1.11
'  OC1CON1bits_OCTSEL2 OC1CON1.12
'  OC1CON1bits_OCFLTA OC1CON1.4
'  OC1CON1bits_OCFLTB OC1CON1.5
'  OC1CON1bits_OCFLTC OC1CON1.6
'  OC1CON1bits_ENFLTA OC1CON1.7
'  OC1CON1bits_ENFLTB OC1CON1.8
'  OC1CON1bits_ENFLTC OC1CON1.9

' OC1CON2 Bits
' OC1CON2bits_OCTRIS OC1CON2.5
' OC1CON2bits_TRIGSTAT OC1CON2.6
' OC1CON2bits_OCTRIG OC1CON2.7
' OC1CON2bits_OC32 OC1CON2.8
' OC1CON2bits_OCINV OC1CON2.12
' OC1CON2bits_FLTTRIEN OC1CON2.13
' OC1CON2bits_FLTOUT OC1CON2.14
' OC1CON2bits_FLTMD OC1CON2.15
' OC1CON2bits_SYNCSEL0 OC1CON2.0
' OC1CON2bits_SYNCSEL1 OC1CON2.1
' OC1CON2bits_SYNCSEL2 OC1CON2.2
' OC1CON2bits_SYNCSEL3 OC1CON2.3
' OC1CON2bits_SYNCSEL4 OC1CON2.4
' OC1CON2bits_DCB0 OC1CON2.9
' OC1CON2bits_DCB1 OC1CON2.10
' OC1CON2bits_FLTMODE OC1CON2.14

' CCP1CON1L Bits
    CCP1CON1Lbits_CCSEL = 0 ' CCP1CON1L.4,0 = Output compare/PWM/timer peripheral (exact function is selected by the MOD<3:0> bits)
    CCP1CON1Lbits_T32_CCP1CON1L = 0 ' CCP1CON1L.5, 0 = Uses 16-bit time base for timer, single edge output compare or input capture function
    CCP1CON1Lbits_TMRSYNC = 0 ' CCP1CON1L.11, 0 = Module time base clock is not synchronized to the internal system clocks
    CCP1CON1Lbits_CCPSLP = 0 ' CCP1CON1L.12, 0 = Module does not operate in Sleep modes
    CCP1CON1Lbits_CCPSIDL = 0 ' CCP1CON1L.13,  0 = Continues module operation in Idle mode
    CCP1CON1Lbits_CCPON = 0 ' CCP1CON1L.15, 1 = Module is enabled with an operating mode specified by the MOD<3:0> control bits
    CCP1CON1Lbits_MOD0 = 1 ' CCP1CON1L.0  0101 = Dual Edge Compare mode, buffered PWM
    CCP1CON1Lbits_MOD1 = 0 ' CCP1CON1L.1
    CCP1CON1Lbits_MOD2 = 1 ' CCP1CON1L.2
    CCP1CON1Lbits_MOD3 = 0 ' CCP1CON1L.3
    CCP1CON1Lbits_TMR32 = 0 ' CCP1CON1L.5 0 = Uses 16-bit time base for timer, single edge output compare or input capture function
    CCP1CON1Lbits_TMRPS0 = 0 'CCP1CON1L.6  Time Base Prescale Select bits,11 = 1:64 Prescaler,10 = 1:16 Prescaler, 01 = 1:4 Prescaler, 00 = 1:1 Prescaler
    CCP1CON1Lbits_TMRPS1 = 0 ' CCP1CON1L.7
    CCP1CON1Lbits_CLKSEL0 = 0 ' CCP1CON1L.8  000 = System clock
    CCP1CON1Lbits_CLKSEL1 = 0 'CCP1CON1L.9
    CCP1CON1Lbits_CLKSEL2 = 0 'CCP1CON1L.10
    CCP1CON1Lbits_CCPMOD0 = 1 ' CCP1CON1L.0    0101 = Dual Edge Compare mode, buffered PWM
    CCP1CON1Lbits_CCPMOD1 = 0 ' CCP1CON1L.1
    CCP1CON1Lbits_CCPMOD2 = 1 ' CCP1CON1L.2
    CCP1CON1Lbits_CCPMOD3 = 0 ' CCP1CON1L.3

' CCP1CON1H Bits '    'CCP1CON1Hbits_ALTSYNC CCP1CON1H.5
'    CCP1CON1Hbits_ONESHOT CCP1CON1H.6
    CCP1CON1Hbits_TRIGEN = 0 'CCP1CON1H.7
'    CCP1CON1Hbits_RTRGEN CCP1CON1H.14
'    CCP1CON1Hbits_OPSSRC CCP1CON1H.15
    CCP1CON1Hbits_SYNC0 = 0 ' CCP1CON1H.0  Select Sync/Trigger source (Self-sync)
    CCP1CON1Hbits_SYNC1 = 0 ' CCP1CON1H.1
    CCP1CON1Hbits_SYNC2 = 0 ' CCP1CON1H.2
    CCP1CON1Hbits_SYNC3 = 0 ' CCP1CON1H.3
    CCP1CON1Hbits_SYNC4 = 0 ' CCP1CON1H.4
'    CCP1CON1Hbits_OPS0 CCP1CON1H.8
'    CCP1CON1Hbits_OPS1 CCP1CON1H.9
'    CCP1CON1Hbits_OPS2 CCP1CON1H.10
'    CCP1CON1Hbits_OPS3 CCP1CON1H.11
'    CCP1CON1Hbits_OPSRC CCP1CON1H.15
'    CCP1CON1Hbits_IOPS0 CCP1CON1H.8
'    CCP1CON1Hbits_IOPS1 CCP1CON1H.9
'    CCP1CON1Hbits_IOPS2 CCP1CON1H.10
'    CCP1CON1Hbits_IOPS3 CCP1CON1H.11

' CCP1CON2L Bits
'$define CCP1CON2Lbits_SSDG CCP1CON2L.12
'$define CCP1CON2Lbits_ASDGM CCP1CON2L.14
'$define CCP1CON2Lbits_PWMRSEN CCP1CON2L.15
'$define CCP1CON2Lbits_ASDG0 CCP1CON2L.0
'$define CCP1CON2Lbits_ASDG1 CCP1CON2L.1
'$define CCP1CON2Lbits_ASDG2 CCP1CON2L.2
'$define CCP1CON2Lbits_ASDG3 CCP1CON2L.3
'$define CCP1CON2Lbits_ASDG4 CCP1CON2L.4
'$define CCP1CON2Lbits_ASDG5 CCP1CON2L.5
'$define CCP1CON2Lbits_ASDG6 CCP1CON2L.6
'$define CCP1CON2Lbits_ASDG7 CCP1CON2L.7

' CCP1CON2H Bits
    CCP1CON2Hbits_OCAEN = 1 ' CCP1CON2H.8    Enable desired output signals (OC1A)
'    CCP1CON2Hbits_OCBEN = 1 ' CCP1CON2H.9
'    CCP1CON2Hbits_OCCEN CCP1CON2H.10
'    CCP1CON2Hbits_OCDEN CCP1CON2H.11
'    CCP1CON2Hbits_OCEEN CCP1CON2H.12
'    CCP1CON2Hbits_OCFEN CCP1CON2H.13
'    CCP1CON2Hbits_OENSYNC CCP1CON2H.15
'    CCP1CON2Hbits_ICS0 CCP1CON2H.0
'    CCP1CON2Hbits_ICS1 CCP1CON2H.1
'    CCP1CON2Hbits_ICS2 CCP1CON2H.2
'    CCP1CON2Hbits_AUXOUT0 CCP1CON2H.3
'    CCP1CON2Hbits_AUXOUT1 CCP1CON2H.4
'    CCP1CON2Hbits_ICGSM0 CCP1CON2H.6
'    CCP1CON2Hbits_ICGSM1 CCP1CON2H.7
'    CCP1CON2Hbits_ICSEL0 CCP1CON2H.0
'    CCP1CON2Hbits_ICSEL1 CCP1CON2H.1
'    CCP1CON2Hbits_ICSEL2 CCP1CON2H.2

' CCP1CON3L Bits
'$define CCP1CON3Lbits_DT0 CCP1CON3L.0
'$define CCP1CON3Lbits_DT1 CCP1CON3L.1
'$define CCP1CON3Lbits_DT2 CCP1CON3L.2
'$define CCP1CON3Lbits_DT3 CCP1CON3L.3
'$define CCP1CON3Lbits_DT4 CCP1CON3L.4
'$define CCP1CON3Lbits_DT5 CCP1CON3L.5

' CCP1CON3H Bits
'    CCP1CON3Hbits_POLBDF CCP1CON3H.4
    CCP1CON3Hbits_POLACE = 0 ' CCP1CON3H.5  Configure output polarity (Active High)
'    CCP1CON3Hbits_OETRIG CCP1CON3H.15
'    CCP1CON3Hbits_PSSBDF0 CCP1CON3H.0
'    CCP1CON3Hbits_PSSBDF1 CCP1CON3H.1
'    CCP1CON3Hbits_PSSACE0 CCP1CON3H.2
'    CCP1CON3Hbits_PSSACE1 CCP1CON3H.3
    CCP1CON3Hbits_OUTM0 = 0 ' CCP1CON3H.8  Set advanced output modes (Standard output)
    CCP1CON3Hbits_OUTM1 = 0 ' CCP1CON3H.9
    CCP1CON3Hbits_OUTM2 = 0 ' CCP1CON3H.10
'    CCP1CON3Hbits_OSCNT0 CCP1CON3H.12
'    CCP1CON3Hbits_OSCNT1 CCP1CON3H.13
'    CCP1CON3Hbits_OSCNT2 CCP1CON3H.14

' CCP1STAT Bits
'$define CCP1STATbits_ICBNE_CCP1STAT CCP1STAT.0
'$define CCP1STATbits_ICOV_CCP1STAT CCP1STAT.1
'$define CCP1STATbits_ICDIS CCP1STAT.2
'$define CCP1STATbits_SCEVT CCP1STAT.3
'$define CCP1STATbits_ASEVT CCP1STAT.4
'$define CCP1STATbits_TRCLR CCP1STAT.5
'$define CCP1STATbits_TRSET CCP1STAT.6
'$define CCP1STATbits_CCPTRIG CCP1STAT.7
'$define CCP1STATbits_ICGARM CCP1STAT.10
'$define CCP1STATbits_TRIG CCP1STAT.7

' CCP1STATL Bits
'$define CCP1STATLbits_ICBNE_CCP1STATL CCP1STATL.0
'$define CCP1STATLbits_ICOV_CCP1STATL CCP1STATL.1
'$define CCP1STATLbits_ICDIS CCP1STATL.2
'$define CCP1STATLbits_SCEVT CCP1STATL.3
'$define CCP1STATLbits_ASEVT CCP1STATL.4
'$define CCP1STATLbits_TRCLR CCP1STATL.5
'$define CCP1STATLbits_TRSET CCP1STATL.6
'$define CCP1STATLbits_CCPTRIG CCP1STATL.7
'$define CCP1STATLbits_ICGARM CCP1STATL.10
'$define CCP1STATLbits_TRIG CCP1STATL.7

' CCP1STATH Bits
'$define CCP1STATHbits_RAWIP CCP1STATH.0
'$define CCP1STATHbits_RBWIP CCP1STATH.1
'$define CCP1STATHbits_TMRLWIP CCP1STATH.2
'$define CCP1STATHbits_TMRHWIP CCP1STATH.3
'$define CCP1STATHbits_PRLWIP CCP1STATH.4


    CCP1TMRL = 0x0000  'Initialize timer prior to enable module.
    CCP1PRL = 79   'Configure timebase period
    CCP1RA = 0    ' Set the rising edge compare value
    CCP1RB = 50    ' Set the falling edge compare value

    CCP1CON1Lbits_CCPON = 1  ' Turn on MCCP module



 '1. Configure the OCx output for one of the available Peripheral Pin Select pins if available
 'on the OC module you are using. Otherwise, configure the dedicated OCx output pins.
 ' -->Ya hecho en fichero ConfigPines.INC

 '2. Calculate the desired duty cycles and load them into the OCxR register.

 '3. Calculate the desired period and load it into the OCxRS register.

 '4. Select the current OCx as the synchronization source by writing 0x1F to the SYNCSEL<4:0>
 ' bits (OCxCON2<4:0>) and 0 to the OCTRIG bit (OCxCON2<7>).

 '5. Select a clock source by writing to the OCTSEL<2:0> bits (OCxCON1<12:10>).

 '6. Enable interrupts, if required, for the timer and output compare modules. The output compare
 'interrupt is required for PWM Fault pin utilization.

 '7. Select the desired PWM mode in the OCM<2:0> bits (OCxCON1<2:0>).


 '8. Appropriate Fault inputs may be enabled by using the ENFLT<2:0> bits as described in Register 15-1.

 '9. If a timer is selected as a clock source, set the selected timer prescale value. The selected
 'timers prescaler output is used as the clock input for the OCx timer and not the selected  timer output.


  ENDPROC
'** FIN PROCEDIMIENTO: TMR1_Inicializar


'*************************************************************************
'** PROCEDIMIENTO: OC1_Inicializar
'** Ajusta el modulo output compare para el canal 1 de PWM
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC OC2_Inicializar()




  ENDPROC
'** FIN PROCEDIMIENTO: TMR1_Inicializar


'*************************************************************************
'** PROCEDIMIENTO: Inicializar
'** Inicializa los diferentes registros, salidas y entrads de perifericos
'**
'**
'** Parametros de entrada:
'** Parametros de salida:
'**
'*************************************************************************
  PROC Inicializar()
  'Definiciones de pines para los 2 puertos serie

'  'PPS_Output(cOut_Pin_RP0, cOut_Fn_U1TX); UART1 Transmit Connected to RP0
'  RPOR0 = 3                               'UART1 Transmit Connected to RP0
'  'PPS_Input(cIn_Pin_RP1, cIn_Fn_U1RX); UART1  Receive (U1RX)  Connected to RP1
'  rpinr18 = 1                        'UART1  Receive (U1RX)  Connected to RP1
'  'PPS_Output(cOut_Pin_RP7, cOut_Fn_U2TX); UART2 Transmit Connected to RP7
'  rpor3 = %0000010100000000  'RP7 conectada a TX2
'  'PPS_Input(cIn_Pin_RP8, cIn_Fn_U2RX); UART2  Receive (U2RX)  Connected to RP8
'  rpinr19 = 8

'PPS_Output(cOut_Pin_RP0, cOut_Fn_U1TX)' UART1 Transmit Connected to RP0
'PPS_Input(cIn_Pin_RP1, cIn_Fn_U1RX)' UART1  Receive (U1RX)  Connected to RP1
'PPS_Output(cOut_Pin_RP7, cOut_Fn_U2TX)' UART2 Transmit Connected to RP7
'PPS_Input(cIn_Pin_RP8, cIn_Fn_U2RX)' UART2  Receive (U2RX)  Connected to RP8
    InitPPS()


  'REGISTER 9-1: OSCCON: OSCILLATOR CONTROL REGISTER
    OSCCON = %0000000000000000
           ' ||| |||
           ' ||| |||
           ' ||| |||
           ' ||| |||
           ' ||| |||
           ' ||| |||
           ' ||| |||_______ 000 = Fast RC Oscillator (FRC)
           ' |||
           ' |||___________ 000 = Fast RC Oscillator (FRC)

  'REGISTER 9-2: CLKDIV: CLOCK DIVIDER REGISTER
    CLKDIV = %0000000000000000
           '|||||||||||xxxxx
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||
           '|||||||||||__________________ PLLEN: PLL Enable bit, 0 = PLL is only active when a PLL Oscillator mode is selected (OSCCON<14:12> = 011 or 001)
           '||||||||||___________________ CPDIV<1:0>: System Clock Select bits (postscaler select from PLL, 32 MHz clock branch)
           '||||||||_____________________ RCDIV<2:0>: System Frequency Divider Clock Source Select bits, 000 = Fast RC Oscillator (FRC)
           '|||||________________________ DOZEN: Doze Enable bit, 0 = CPU peripheral clock ratio is set to 1:1
           '||||_________________________ DOZE<2:0>: CPU Peripheral Clock Ratio Select bits, 000 = 1:1
           '|____________________________  0 = Interrupts have no effect on the DOZEN bit
    '000= 8 MHz (divide-by-1)

  'REGISTER 9-3: OSCTUN: FRC OSCILLATOR TUNE REGISTER
    OSCTUN = %0000000000000000
    '000000= Center frequency, oscillator is running at factory calibrated frequency

  'REGISTER 9-4: OSCDIV: OSCILLATOR DIVISOR REGISTER
    OSCDIV = %000000000000000 'Oscillator frequency is unchanged (no divider)

    OSCFDIV = %000000000000000

    REFOCONL = %00000000
    REFOCONH = %00000000
    DCOTUN = %0000000000000000
    DCOCON = %0000011100000000




 ' TMR1_Inicializar()
    TMR2_Inicializar()
    TMR3_Inicializar()
    UART1_Inicializar()
    UART2_Inicializar()

    OC1_Inicializar()
    'OC2_Inicializar()
  'VerProtocolo =CREAD PERFIL_ACTIVO + 14 'leo la version del protocolo de la memoria Flash
  'VerProtocolo = VerProtocolo + 48  'Lo paso a ASCII porque siempre se usa en ascii
  'Depuracion = CREAD PERFIL_ACTIVO + 9 'Leo el numero de pista
    CentinelaVive = 0
    TestigoVive = VIVECONECTADO 'Supongo que hay conexin al arrancar

    INTCON2bits_GIE = 1 ' INTCON2.15

  ENDPROC
'** FIN PROCEDIMIENTO: Inicializar




'*************************************************************************
'** PROCEDIMIENTO: TransmitirTramaUART2
'** Transmite una trama por la USART2 a traves del driver RS485
'** Primero activa el pin de transmisin del driver y luego transmite
'**
'*************************************************************************
  PROC TransmitirTramaUART2()
    DIM Tempo AS BYTE = 0

    FOR Tempo = DesdeTxU2 TO HastaTxU2
      HRSOUT2 TramaParaTransmitirU2[Tempo]
      DELAYUS 200
    NEXT Tempo

  ENDPROC
'** FIN PROCEDIMIENTO: TransmitirTramaUART2


'*************************************************************************
'** PROCEDIMIENTO: TransmitirTramaUART1
'** Transmite una trama por la USART1 a traves de Ethernet
'**
'**
'*************************************************************************
  PROC TransmitirTramaUART1()
    DIM Tempo AS BYTE = 0

    FOR Tempo = DesdeTxU1 TO HastaTxU1
      HRSOUT TramaParaTransmitirU1[Tempo]
      DELAYUS 200
    NEXT Tempo

  ENDPROC
'** FIN PROCEDIMIENTO: TransmitirTramaUART2



'*************************************************************************
'** PROCEDIMIENTO: Testear
'** Hace un test con el led que indica que ha arrancado bien
'*************************************************************************


  PROC Testear()

    DELAYMS 1000
    FOR Tempo2_16=100 TO 300 STEP Tempo1_16
      LED1 = ENCENDIDO
      LED2 = APAGADO
      DELAYMS Tempo2_16
      LED1 = APAGADO
      LED2 = ENCENDIDO
      DELAYMS Tempo2_16
    NEXT Tempo2_16
    LED1 = ENCENDIDO
    LED2 = APAGADO

  ENDPROC

'** FIN PROCEDIMIENTO: Testear



'*************************************************************************
'** PROGRAMA PRINCIPAL
'*************************************************************************
'*************************************************************************
'** El programa principal se mantiene haciendo las siguientes tareas principales:
'** 1.-TAREA: COMPROBAR Y CAMBIAR ESTADO LED VIVE
'** 2.-TAREA: COMPROBAR SI HAN CAMBIADO LAS ENTRADAS DIGITALES
'** 3.-TAREA: COMPROBAR SI HE RECIBIDO UNA TRAMA POR LA USART 1
'** 4.-TAREA: COMPROBAR SI HE RECIBIDO UNA TRAMA POR LA USART 2
'*************************************************************************
  Principal:

  Inicializar()

  Tempo1_16 = 50  'Ajusto para hacer 6 encendidos y apagados con el LED
  Testear()
'  PrepararTramaEstado()  'Se prepara y enva la trama de estado de conexin para ver si est OnLine
 ' TransmitirTramaUART1()



  WHILE  'bucle principal


'**************************************************************************
'**** TAREA 1: COMPROBAR Y CAMBIAR ESTADO LED VIVE
'**************************************************************************
    EncenderLedVive()
'   led1 = ~ led1
'   delayms 1000

'**************************************************************************
'**** TAREA 2: COMPROBAR SI HAN CAMBIADO LAS ENTRADAS DIGITALES
'**************************************************************************
    ComprobarEntradas()


'*********************************************************************
'**** TAREA 5: COMPROBAR SI HE RECIBIDO UNA TRAMA DE LA RED DE COMUNICACIONES POR LA USART 1
'*********************************************************************
   IF F_TramaRecibidaU1 = 1  THEN  'Si recibo contestacin
     F_TramaRecibidaU1 = 0

     FOR tempo = 0 TO NumeroBytesTramaU1
       HRSOUT1 BuferRecepcionUSART1[tempo]
     NEXT tempo

  '   AnalizarTramaUSART1()
'     IF ErrorCommsU1 = 0 THEN  'Si la trama viene correcta
'       F_PendienteDeConexion = 0    'Borro flag de estado pendiente de conexion y su contador
'       CentinelaPendienteConexion = 0
'       CentinelaConexion = 0 'borro el centinela porque acabo de recibir una trama buena, para que empiece de nuevo a contar
'       F_EstadoConexion = ONLINE  'Activo conexin online
'       TestigoVive = VIVECONECTADO 'Pongo la cadencia del led vive para indicar conectado
'       ProcesarComandoU1()
'     ELSE  'de ErrorComms=0  'Si la trama viene con errores no abro
'       GOSUB ErrorTransmision
'     ENDIF  'de ErrorComms=0
   ENDIF 'de F_TramaRecibida = 1


 '*********************************************************************
 '**** TAREA 6: COMPROBAR SI HE RECIBIDO UNA TRAMA DE LA RED DE COMUNICACIONES POR LA USART 2
 '*********************************************************************
   IF F_TramaRecibidaU2 = 1  THEN  'Si recibo contestacin
     F_TramaRecibidaU2 = 0

     FOR tempo = 0 TO NumeroBytesTramaU2
       HRSOUT2 BuferRecepcionUSART2[tempo]
     NEXT tempo

  '   AnalizarTramaUSART1()
'     IF ErrorCommsU1 = 0 THEN  'Si la trama viene correcta
'       F_PendienteDeConexion = 0    'Borro flag de estado pendiente de conexion y su contador
'       CentinelaPendienteConexion = 0
'       CentinelaConexion = 0 'borro el centinela porque acabo de recibir una trama buena, para que empiece de nuevo a contar
'       F_EstadoConexion = ONLINE  'Activo conexin online
'       TestigoVive = VIVECONECTADO 'Pongo la cadencia del led vive para indicar conectado
'       ProcesarComandoU1()
'     ELSE  'de ErrorComms=0  'Si la trama viene con errores no abro
'       GOSUB ErrorTransmision
'     ENDIF  'de ErrorComms=0
   ENDIF 'de F_TramaRecibida = 1



  WEND
'************************************
'VALORES POR DEFECTO EN LA FLASH
'************************************

PERFIL_ACTIVO:  CDATA 0,0,0,0,255,2,4,0,0,255,255,255,248,127,2,255  'Configuracin activa
PERFIL_FACTORY: CDATA 0,0,0,0,128,255,1,0,0,255,255,255,255,255,255,255  'Configuracin de fabrica
PERFIL_FIRMA:   CDATA 255,71,65,77,66,79,65,32,70,73,82,77,87,65,82,69 'Sello de la casa

'Posicion 0,1,2,3   --> 4 bytes para serializar cada micro
'Posicion 4-----------> Direccion logica, del 128 al 254 (255 es broadcast)
'Posicion 5-----------> Tiempo de apertura, por defecto 2 segundos
'Posicion 6,7,8-------> Version del firmware esta versin es la 4.00
'Posicion 9,10,11-----> No usado
'Posicion 12,13  ------> Direccin hasta donde est llena la EEPROM externa donde se guardan las tarjetas
                         'Direccin mxima por defecto 32760 = 01111111 11111000 =  7F F8 =  127 248
                         'Posicin 12= 248
                         'Posicin 13= 127
'Posicion 14     ------> Version del protocolo de 1 a 9 ,Esta versin es la 2, se guarda en la variable VerProtocolo


'*************************************************************************
'** FUSES
'*************************************************************************
'Config FSEC = AIVTDIS_OFF, BSEN_OFF, BSS_DISABLED, BWRP_OFF, CSS_DISABLED, CWRP_OFF, GSS_DISABLED, GWRP_OFF
'Config FBSLIM = BSLIM_BSLIM
'Config FSIGN = FNOSC_FRC, IESO_ON, PLLMODE_DISABLED
'Config FOSCSEL = FCKSM_CSDCMD, IOL1WAY_ON, OSCIOFCN_OFF, PLLSS_PLL_FRC, POSCMD_NONE, SOSCSEL_OFF
'Config FOSC = FWDTEN_OFF, FWPSA_PR128, WDTCLK_FRC, WDTCMX_WDTCLK, WDTPS_PS32768, WDTWIN_WIN25, WINDIS_OFF
'Config FWDT = BOREN_ON, DNVPEN_ENABLE, LPCFG_OFF
'Config FPOR = ICS_PGD1, JTAGEN_OFF
'Config FICD = ALTCMPI_DISABLE, ALTI2C1_ALTI2CEN, SOSCHP_ON, TMPRPIN_OFF

'      Config FSEC = AIVTDIS_OFF, BSEN_OFF, BSS_DISABLED, BWRP_OFF, CSS_DISABLED, CWRP_OFF, GSS_DISABLED, GWRP_OFF
'      Config FBSLIM = BSLIM_BSLIM
'      Config FOSCSEL = FNOSC_FRC, IESO_ON, PLLMODE_DISABLED
'      Config FOSC = FCKSM_CSDCMD, IOL1WAY_ON, OSCIOFCN_OFF, PLLSS_PLL_FRC, POSCMD_NONE, SOSCSEL_OFF
'      Config FWDT = FWDTEN_OFF, FWPSA_PR128, WDTCLK_FRC, WDTCMX_WDTCLK, WDTPS_PS32768, WDTWIN_WIN25, WINDIS_OFF
'      Config FPOR = BOREN_ON, DNVPEN_ENABLE, LPCFG_OFF
'      Config FICD = ICS_PGD1, JTAGEN_OFF
'      Config FDEVOPT1 = ALTCMPI_DISABLE, ALTI2C1_ALTI2CEN, SOSCHP_ON, TMPRPIN_OFF


END